﻿//パネルの作成　ここから
var win = new Window ('dialog', 'ランダムパスワード',[0,0,215,315]);//外枠
//桁数　ここから
win.digitTitel = win.add('panel',[20,15,195,70],'桁数');  //中枠
var check01 = win.add("radiobutton",[30,40,75,55]," 4桁");//ラジオボタン
var check02 = win.add("radiobutton",[80,40,125,55]," 8桁");//ラジオボタン
var check03 = win.add("radiobutton",[130,40,190,55]," 12桁");//ラジオボタン
//桁数　ここまで
//文字　ここから
win.textTitel = win.add('panel',[20,90,195,195],'使用文字');//中枠
var check04 = win.add("radiobutton",[30,115,80,130]," 数字");//ラジオボタン
var check05 = win.add("radiobutton",[30,140,125,155]," 数字 + 英字");//ラジオボタン
var check06 = win.add("radiobutton",[30,165,170,180]," 数字 + 英字 + 記号");//ラジオボタン
//文字　ここまで

//実行ボタン　ここから
var okBtn = win.add("button", [20,215,195,250], "実行");
var noBtn = win.add("button",[20,260,195,295],"キャンセル");
//実行ボタン　ここまで
//パネルの作成　ここまで

//パネル　初期値ここから
check01.value = true;//オフセットにチェック
check04.value = true;//オフセットにチェック
//パネル　初期値ここまで

//キャンセル　ここから
noBtn.onClick = function(){ 
    win.close();  //パネル外枠閉じる
} ;
//キャンセル　ここまで

//実行　ここから
okBtn.onClick = function(){
    win.close(); //パネル外枠閉じる 
    generate(); //メイン処理
};
//実行　ここまで

win.center();   //センター表示
win.show();　//パネルの表示

// ランダムな英数字を生成する関数 ここから
function random(length) {
    var chars = '0123456789';   //使用する数字 
    var english = 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';   //使用する 英字
    var symbol = '@#$%&!()=+-*/'    //使用する 記号
    
    if(check05.value){
       chars += english;
    } else if(check06.value){
      chars += english + symbol;
    };

    var result = "";    //空変数
    for (var i = 0; i < length; i++) {  //lengthの数だけ繰り返す
        result += chars[Math.floor(Math.random() * chars.length)];  //ランダムに指定桁の英数字記号をつくる
     };

    return result;
}
// ランダムな英数字を生成する関数 ここまで

//メイン処理　ここから
function generate(){
    if (check01.value){
        var password = random(4);  // 4桁のランダムなパスワードを生成
    } else if (check02.value){
         var password = random(8);  // 8桁のランダムなパスワードを生成
    } else if ( check03.value){
        var password = random(12);  // 12桁のランダムなパスワードを生成
    };
    alert("Your password is: \n【 " + password + " 】");   // パスワードをアラート画面に表示
    try{
        // パスワードをテキストファイルに書き出す　ここから
        var file = new File("~/Desktop/password.txt");
        file.open("w"); //ファイルに書き込み
        file.write(password);   //書き込む内容
        file.close();   //ファイルを閉じる
        // パスワードをテキストファイルに書き出す　ここまで
    } catch (e) {
        alert("エラーが発生しました: " + e.message);  
    };
}
//メイン処理　ここまで